Name:           ccls
Version:        0.20181111.1
Release:        1%{?dist}
Summary:        C/C++/ObjC language server supporting cross references, hierarchies, completion and semantic highlighting

License:        ASL 2.0 
URL:            https://github.com/MaskRay/ccls
Source0:        https://github.com/MaskRay/ccls/archive/0.20181111.1.tar.gz
Source1:        https://github.com/MaskRay/ccls/archive/0.20181111.1.zip

BuildRequires:  cmake >= 3.8
BuildRequires:  clang
BuildRequires:  clang-devel
BuildRequires:  llvm-devel
BuildRequires:  zlib-devel
BuildRequires:  libstdc++-devel
BuildRequires:  ncurses-devel
BuildRequires:  rapidjson-devel
Requires:       clang
Requires:       ncurses-c++-libs

%global debug_package %{nil}

%description
ccls, which originates from cquery, is a C/C++/Objective-C language server.

It has a global view of the code base and support a lot of cross reference features, see wiki/FAQ. It starts indexing the whole project (including subprojects if exist) parallelly when you open the first file, while the main thread can serve requests before the indexing is complete. Saving files will incrementally update the index.

Compared with cquery, it makes use of C++17 features, has less third-party dependencies and slimmed-down code base. It leverages Clang C++ API as clangd does, which provides better support for code completion and diagnostics. Refactoring is a non-goal as it can be provided by clang-include-fixer and other Clang based tools.


%prep
%autosetup


%build
cmake -H. -BRelease -DCMAKE_INSTALL_PREFIX=%{install_prefix} -DSYSTEM_CLANG=on -DUSE_SHARED_LLVM=on -DLLVM_ENABLE_RTTI=on
cmake --build Release


%install
mkdir -p %{buildroot}%{_bindir}
install Release/%{name} %{buildroot}%{_bindir}/%{name}


%files
%{_bindir}/%{name}


%changelog
* Mon Nov  12 2018 Yotam Nachum <fedora@yotam.net>
- Initial Fedora package
